# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()	%{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/jboss/ejb3/jboss-ejb3-security/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define namedversion %{version}

Name:           jboss-ejb3-security
Version:        1.0.2
Release:        0.5%{?dist}
Epoch:          0
Summary:        JBoss EJB3 Security
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/ejb3/tags/jboss-ejb3-security-1.0.2/ && tar cjf jboss-ejb3-security-1.0.2.tar.bz2 jboss-ejb3-security-1.0.2/
Source0:        jboss-ejb3-security-1.0.2.tar.bz2
Source1:        jboss-ejb3-security-jpp-depmap.xml
Source2:        jboss-ejb3-security-settings.xml
Source3:	jboss-ejb3-security-component-info.xml
Patch0:		%{name}-pom.patch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
Requires:       java >= 0:1.5.0
Requires:       jacc_1_1_api
Requires:       jboss-aop2
Requires:       jboss-common-core
Requires:       jboss-common-logging-spi
Requires:       jboss-current-invocation-aspects
Requires:       jboss-ejb3-build
Requires:       jboss-ejb3-ext-api
Requires:       jboss-ejb3-ext-api-impl
Requires:       jboss-ejb3-interceptors
Requires:       jboss-metadata
Requires:       jboss-security-spi
Requires:       jbosssx2
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-rar
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-jboss-deploy-plugin
BuildRequires:  maven-release-plugin
BuildRequires:  maven-enforcer-rule-api
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:	codehaus-stax-api
BuildRequires:  jacc_1_1_api
BuildRequires:  jboss-aop2
BuildRequires:  jboss-aspects-build
BuildRequires:  jboss-common-core
BuildRequires:  jboss-common-logging-spi
BuildRequires:  jboss-current-invocation-aspects
BuildRequires:  jboss-ejb3-build
BuildRequires:  jboss-ejb3-ext-api
BuildRequires:  jboss-ejb3-ext-api-impl
BuildRequires:  jboss-ejb3-interceptors
BuildRequires:  jboss-metadata
BuildRequires:  jboss-security-spi
BuildRequires:	jboss-parent
BuildRequires:  jbosssx2
BuildRequires:  jbossws
BuildRequires:  junit4
BuildRequires:  qdox
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss EJB security.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%patch0 -p1
%{_bindir}/find . -name "*.jar" | %{_bindir}/xargs -t %{__rm} -f

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        -Djboss.repository.root=file://$(pwd)/maven2-brew \
        deploy javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -p -m 644 target/jboss-ejb3-security.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -p -m 644 target/jboss-ejb3-security-client.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-client-%{version}.jar
install -p -m 644 target/jboss-ejb3-security-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-sources-%{version}.jar
%{jar} -cf $RPM_BUILD_ROOT%{_javadir}/%{name}-javadoc-%{version}.jar -C target/site/apidocs/ .
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -s ${jar} `/bin/echo $jar | sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -p -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.jboss.ejb3 jboss-ejb3-security %{namedversion} JPP %{name}

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
mvn-jpp deploy:deploy-file -e -DpomFile=pom.xml -DrepositoryId=maven2-brew \
    -Durl=file:///%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew \
    -Dfile=$RPM_BUILD_ROOT%{_javadir}/%{name}-javadoc-%{version}.jar \
    -Dclassifier=javadoc

install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
cp -p %{SOURCE3} $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{version}-brew`
sed -i "s/@VERSION@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
cp -p %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-ejb3-security.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-client-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-ejb3-security-client.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-javadoc-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-ejb3-security-javadoc.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-sources-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-ejb3-security-sources.jar
cp -p pom.xml $RPM_BUILD_ROOT%{repodirlib}/jboss-ejb3-security.pom
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-%{version}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-client-%{version}.jar
%{_javadir}*/%{name}-client.jar
%{_javadir}*/%{name}-javadoc-%{version}.jar
%{_javadir}*/%{name}-javadoc.jar
%{_javadir}*/%{name}-sources-%{version}.jar
%{_javadir}*/%{name}-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Jan 18 2011 Martha Benitez <mbenitez@redhat.com> - 0:1.0.2-0.5
- Add pom.patch to use jboss-ejb3-build 1.0.13 and jboss-javaee 5.0.2

* Tue Jan 18 2011 Martha Benitez <mbenitez@redhat.com> - 0:1.0.2-0.4
- Rebuild for MEAD
- Change BR junit44 to junit4
- Add BR qdox

* Thu Nov 25 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.2-0.3
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add BR codehaus-stax-api, jboss-aspects-build

* Thu Jun 03 2010 David Walluck <dwalluck@redhat.com> 0:1.0.2-0.2
- add maven2-brew to repolib
- clean up jpp-depmap

* Thu May 27 2010 David Walluck <dwalluck@redhat.com> 0:1.0.2-0.1
- 1.0.2

* Thu May 06 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.1-1.1.1
- rebuilt

* Mon Apr 12 2010 Yong Yang <yyang@redhat.com> 0:1.0.1-1.1
- Fix depmaps for dtdparser and ejb3-persistence
- Rebuild for generating signed jar

* Fri Dec 04 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0.1-1
- Upgrade to 1.0.1
- Change jboss-parent.pom to BR jboss-parent

* Fri Nov 13 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0.0-1.3
- Add client.jar, sources.jar and javadoc.jar to repolib

* Thu Sep 17 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-1.2
- Add repolib

* Mon Aug 31 2009 Yong Yang <yyang@redhat.com> - 0:1.0.0-1.1
- Import from jpackage
- Change BR maven-shared-enforcer-rule-api to maven-enforcer-rule-api
- BR jbossws
- Add jpp depmap for jboss-parent, jsr173_api, jbossws

* Sat Jul 25 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.0.0-1
- first release
